uses sbDSP,HTime,FFT_Unit;

procedure VIDMode(Mode : Byte);assembler;
asm
  mov  ah,$00;
  mov  al,mode;
  int 10h;
end;

procedure SetPalette;
function F(X:Real):Integer;
begin
  F:=Round((1-Exp(-X))*63);
end;
var i:integer;
begin
  Port[$3C8]:=0;

  Port[$3C9]:=0;
  Port[$3C9]:=0;
  Port[$3C9]:=0;

  for I:=1 to 255 do begin
    Port[$3C9]:=F(I/16);
    Port[$3C9]:=(F(I/4)-F(I/16))*2;
    Port[$3C9]:=0;
  end;
end;

type TScr = array[0..199,0..319] of Byte;
var Scr: TScr absolute $A000:$0000;

var B,C:TComplexArray;
    I,J,K:Integer;

const Freq:Word=8192;
var SoundBuf:array[0..N*2-1+32] of Byte;

var BIOSTicks:Longint absolute $40:$6C;
    T1,T2:Longint;
    TT1,TT2:Longint;

begin
  WriteLn; WriteLn;
  if EnvironmentSet then begin
    if InitSBFromEnv then begin
      writeln('Sound card initialized correctly using the BLASTER environment variable!');
      writeln('DSP version ', GetDSPVersion);
    end
    else begin
      writeln('Error initializing sound card!');
      Halt(255);
    end;
  end
  else begin
    writeln('BLASTER environment variable not set, using default settings');
    WriteLn('IRQ = 5    Base IO = $220    DMA Channel = 1');
    if Initsb(5, $220, 1) then begin
      writeln('Sound card initialized correctly!');
      writeln('DSP version ', GetDSPVersion);
    end
    else begin
      writeln('Error initializing sound card!');
      Halt(255);
    end;
  end;

  VIDMode($13); SetPalette;

  T1:=-BIOSTicks;
  J:=0;
  TT1:=0; TT2:=0;
  repeat


    Dec(TT1,HTimer);
    PauseSound;
    StartDMAADC(@SoundBuf,N*2+32,Freq,2);  {stereo}
{                            ^^^  32    뢠 砫}
{                                   - . }

    repeat until (Port[$60]=1) or WasSbIrq; { 砭  }
    WasSbIrq:=False;
    Inc(TT1,HTimer);

    Dec(TT2,HTimer);

    for I:=0 to N-1 do begin
      B[I].Re:=SoundBuf[I*2+16]-128;   {祬-  ⥫  砫 }
      B[I].IM:=SoundBuf[I*2+1+16]-128; {墮  }
    end;

    FFTEnergy(B);

    for I:=0 to N div 2-1 do begin
      B[I].Re:=Round(Sqrt(Word(B[I].Re)));
      B[I].IM:=Round(Sqrt(Word(B[I].IM)));
      if B[I].Re>127 then B[I].Re:=127;
      if B[I].IM>127 then B[I].IM:=127;
      if B[I].Re<2 then B[I].Re:=0;
      if B[I].IM<2 then B[I].IM:=0;
    end;

    {  ᥩ ᯥ  ᣫ   }
    for I:=1 to N div 2 - 2 do B[I-1].Re:=(B[I].Re+B[I-1].Re) div 2;
    for I:=1 to N div 2 - 2 do B[I-1].IM:=(B[I].IM+B[I-1].IM) div 2;

    for I:=1 to N div 2 - 2 do B[I-1].Re:=(B[I].Re+B[I-1].Re) div 2;
    for I:=1 to N div 2 - 2 do B[I-1].IM:=(B[I].IM+B[I-1].IM) div 2;

    for I:=1 to N div 2 - 2 do begin
      for K:=-128 to 128 do Scr[164-I,160+K]:=0;
      for K:=0 to B[I].Re do Scr[164-I,160-K]:=K+1;
      for K:=0 to B[I].IM do Scr[164-I,160+K]:=K+1;
    end;

    Inc(TT2,HTimer);

    if Port[$60]=1 then Break;

    Inc(J);
  until False;

  Inc(T1,BIOSTicks);

  VIDMode(3);

  WriteLn('time = ',T1/18.2:0:2,'   j = ',J,'   freq = ',J/T1*18.2:0:2);

  WriteLn('blaster time = ',TT1*HTimerRes:0:2,'   1 time = ',TT1*HTimerRes/J:0:6);
  WriteLn('work time    = ',TT2*HTimerRes:0:2,'   1 time = ',TT2*HTimerRes/J:0:6);

end.
